<?php

declare(strict_types=1);

namespace A2G\A2gMaps\Domain\Model;

use TYPO3\CMS\Extbase\DomainObject\AbstractEntity;
use TYPO3\CMS\Extbase\Domain\Model\FileReference;
use TYPO3\CMS\Extbase\Annotation\ORM\{
    Cascade,
    Lazy
};
use TYPO3\CMS\Extbase\Persistence\Generic\LazyLoadingProxy;

/**
 * This file is part of the "altogether Products" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * (c) 2021 Raphael Martin <raphy.martin@gmail.com>, none
 */

/**
 * Marker
 */
class Marker extends AbstractEntity {

    /**
     * mapIcon
     *
     * @var FileReference
     * @Cascade("remove")
     * @Lazy
     */
    protected $mapIcon = null;
    
    /**
     * 
     * @return null|FileReference
     */
    public function getMapIcon(): ?FileReference {
        if ($this->mapIcon instanceof LazyLoadingProxy) {
            $this->mapIcon = $this->mapIcon->_loadRealInstance();
        }
        return $this->mapIcon;
    }
    
    /**
     * 
     * @return string
     */
    public function getMapConfig(): string {
        return $this->mapConfig;
    }
}